from bpy.types import Object
from typing import Union

import pyedm
import animation as anim
import utils

# Returns arg visibility node or None
def extract_visibility_animation(obj: Object) -> Union[None, pyedm.VisibilityNode]:
    if obj.animation_data and obj.animation_data.action:
        action = obj.animation_data.action
        
        arg = utils.extract_arg_number(action.name)
        if arg >= 0:
            avis = anim.extract_anim_float(action, 'VISIBLE')
            if avis:
                vis = pyedm.VisibilityNode("v_" + obj.name)
                vis.setArguments([[arg, avis]])
                return vis
            
    return None